//
//		IICCJ Class Library Ver 1.00
//		iiccj a
//
//		敪F  LFȂ  nrF95/NT  FC++
//		-----------------------------------------------
//		  	F	BitMap (DIB) Object
//		NXF	icj_dib
//		  I	F	
//		File敪F	NX`(.cpp)
//		쐬	F	{ mu
//
//		Rev		t			ύX_
//		-----	----------	----------------------------------------------
//		1.0.0	1997.05.31	8bitFŃ[X
//		1.0.1	1997.06.01	pbgGg[֘Aǉ
//		1.0.2	1997.12.07	icj_class ɑgݍ
//
//
#ifndef  _ICJ_DIB_H_
#define  _ICJ_DIB_H_
#include <windows.h>
#include <memory.h>

enum  BITMAPTYPE {BMRESOURCE, BMFILE, BMDIBSECT, BMMEMORY};
///////////////////////////////////////////////////////////////////////////////
//	chaNX
///////////////////////////////////////////////////////////////////////////////
class  icj_dib
{
	//	oϐ
	protected:
	LPBITMAPFILEHEADER	m_bmfh;			// t@ĈݗL
	LPBITMAPINFO		m_bmi;
	LPBITMAPINFOHEADER	m_bmih;
	LPRGBQUAD			m_quad;
	int					m_quads;		// RGBQUADzvf
	LPBYTE				m_bytes;
	LPLOGPALETTE		m_lpal;
	LPPALETTEENTRY		m_pal;
	int					m_type;
	int					m_width;
	int					m_height;
	int					m_pitch;
	BOOL				m_topdown;		// gbv_Ei[^
	BOOL				m_attached;
	BOOL				m_ronly;		// ύX֎~ DIB
	HANDLE				m_file;
	HANDLE				m_fmap;
	//
	//	DIB ֐
	public:
	virtual BOOL		attach (const char *);
	virtual BOOL		attach (WORD);
	virtual void		detach ();
	virtual BITMAPINFO	*create (int width, int height, int depth,
								LPRGBQUAD quad = NULL, int quads = 0);
	virtual BOOL		setBit (int x, int y, DWORD data);
	virtual DWORD		getBit (int x, int y);

	static  BOOL		setDefQuad (int depth, LPRGBQUAD quad);
	static  BOOL		setDefEntry(int depth, LPPALETTEENTRY entry);
	//
	//	DIB wp[֐
	protected:
	virtual int			calcPitch ();
	virtual void		initVars ();
	virtual BOOL		quad2palette ();
	//
	//	vpeB֐
	public:
	LPPALETTEENTRY		getPalEntry ();
	LPLOGPALETTE		getLogPal ();
	LPBYTE				getBytes ();
	BOOL				setBytes (LPBYTE);
	int					getWidth ();
	int					getHeight ();
	int					getPitch ();
	int					getDepth ();
	LPBITMAPINFO		getBmpinfo ();

	icj_dib ();
	~icj_dib();
};

#endif //_ICJ_DIB_H_
