//
//		IICCJ Class Library Ver 1.00
//		iiccj a
//
//		敪F  LFȂ  nrF95/NT  FC++
//		-----------------------------------------------
//		  	F	Xg[NX
//		NXF	icj_stream
//		  I	F	
//		File敪F	NX`(.h)
//		쐬	F	{ mu
//
//		Rev		t			ύX_
//		-----	----------	----------------------------------------------
//		1.0.0	1998.03.22	
//
#ifndef  _ICJ_STREAM_H_
#define  _ICJ_STREAM_H_
#include <windows.h>

enum ICJSEEK {ICJSEEK_TOP, ICJSEEK_CUR, ICJSEEK_END};
///////////////////////////////////////////////////////////////////////////////
//	t@C^ꃉbp[Xg[
///////////////////////////////////////////////////////////////////////////////
class __declspec(novtable) icj_stream {
	public:
	virtual DWORD	read (LPVOID, DWORD, DWORD) = 0;
	virtual DWORD	write (LPVOID, DWORD, DWORD) = 0;
	virtual BOOL	seek (DWORD, LONG) = 0;
	virtual BOOL	rewind () = 0;
	virtual DWORD	tell () = 0;
	virtual DWORD	getSize () = 0;
	virtual BOOL	close () = 0;
};

class icj_mstream : public icj_stream {
	public:
	virtual DWORD	read (LPVOID, DWORD, DWORD);
	virtual DWORD	write (LPVOID, DWORD, DWORD);
	virtual BOOL	seek (DWORD, LONG);
	virtual BOOL	rewind ();
	virtual DWORD	tell ();
	virtual DWORD	getSize ();
	virtual BOOL	close ();
	//
	//	쐬^J
	virtual LPVOID	create (DWORD, DWORD, BOOL fixed, BOOL purge = TRUE);
	virtual LPVOID	open (LPCTSTR, DWORD, BOOL fixed, BOOL purge = TRUE);
	virtual LPVOID	open (HANDLE, DWORD, DWORD, BOOL fixed, BOOL purge = TRUE);
	virtual BOOL	attach (LPVOID, DWORD);
	//
	//	
	virtual LPVOID	isolate ();
	//
	//	vpeB擾
	virtual DWORD	getRealSize ();
	//
	//	
	protected:
	virtual void	init ();
	//
	//	oϐ
	private:
	DWORD			m_ptr;
	DWORD			m_cur;
	DWORD			m_eof;
	DWORD			m_size;
	DWORD			m_unit;
	BOOL			m_purge;
	BOOL			m_fixed;

	public:
	icj_mstream ();
	virtual ~icj_mstream ();
};

class icj_fstream : public icj_stream {
	public:
	virtual DWORD	read (LPVOID, DWORD, DWORD);
	virtual DWORD	write (LPVOID, DWORD, DWORD);
	virtual BOOL	seek (DWORD, LONG);
	virtual BOOL	rewind ();
	virtual DWORD	tell ();
	virtual DWORD	getSize ();
	virtual BOOL	close ();
	//
	//	쐬^J
	virtual BOOL	create (LPCTSTR, BOOL purge = FALSE);
	virtual BOOL	open (LPCTSTR, BOOL ronry = FALSE, BOOL purge = FALSE);
	virtual BOOL	attach (HANDLE, BOOL close = TRUE);
	//
	//	폜^
	virtual BOOL	remove ();
	virtual HANDLE	isolate ();
	//
	//	vpeB擾
	HANDLE			getFileHandle () {return  m_hfile;}
	//
	//	
	protected:
	virtual void	init ();
	BOOL			copyname (LPCTSTR);
	//
	//	oϐ
	private:
	HANDLE			m_hfile;
	BOOL			m_close;
	BOOL			m_purge;
	BOOL			m_ronly;
	LPTSTR			m_fname;

	public:
	icj_fstream ();
	virtual ~icj_fstream ();
};

#endif //_ICJ_STREAM_H_
