/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Rendering Thread
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.52D	2010/10/30	ʃ_OThread
 **------------------------------------------------------------------------*/
#ifndef  _N80_RENDER_H_
#define  _N80_RENDER_H_
#include "../lib/icj_thread.h"
#include "../n80/n80_directx.h"
#include "../n80/n80_form.h"
/**==========================================================================
 **		Z80XbhNX
 **========================================================================*/
class n80_render : public icj_thread {
	//-----------------------------------------------------------------------
	//	Xbh֐
	//-----------------------------------------------------------------------
	public:
	virtual BOOL		sync(WPARAM verb);		// \tgEFA~
	virtual void		desync();				// \tgEFAĊJ
	//-----------------------------------------------------------------------
	//	override/helper֐
	//-----------------------------------------------------------------------
	protected:
	virtual void		enter();				// N80 render thread start enter
	//-----------------------------------------------------------------------
	//	oϐ
	//-----------------------------------------------------------------------
	private:
	HANDLE				m_hevt_sync;			// sync stop request event from primary thread
	HANDLE				m_hevt_ack;				// ack accept response event from z80 thread
	//-----------------------------------------------------------------------
	//	vpeB
	//-----------------------------------------------------------------------
	public:
	//-----------------------------------------------------------------------
	//	RXgN^^fXgN^
	//-----------------------------------------------------------------------
	public:
	n80_render();
	virtual ~n80_render();
};
#endif //_N80_RENDER_H_
